#include <stdio.h>
#include <stdlib.h>

// maximum number of each value in matrix or vector
#define NUMMAX 10

void init_array(long *data, int len, unsigned int seed);

// row count in a matrix
#define M_ROW 2
// column count in a matrix
#define M_COL 2


int main(int argc, char *argv[])
{
  long *matrix, *vector, *answer;
  int i, j;

  matrix = (long*)malloc(M_ROW * M_COL * sizeof(long));
  vector = (long*)malloc(M_COL * sizeof(long));
  answer = (long*)malloc(M_ROW * sizeof(long));
  if (matrix == NULL || vector == NULL || answer == NULL) {
    fprintf(stderr, "malloc error\n");
    return 1;
  }
  init_array(matrix, M_ROW * M_COL, 0);
  init_array(vector, M_COL, 1);

  /* calc */
  for (i = 0; i < M_ROW; i++) {
    answer[i] = 0;
    for (j = 0; j < M_COL; j++) {
      answer[i] += matrix[M_COL*i+j] * vector[j];
    }
  }

  /* print */
  printf("Matrix\n");
  for (i = 0; i < M_ROW; i++) {
    printf("  ");
    for (j = 0; j < M_COL; j++) {
      printf("%ld ", matrix[M_COL*i+j]);
    }
    printf("\n");
  }
  printf("Vector\n");
  for (i = 0; i < M_COL; i++)
    printf("  %ld\n", vector[i]);
  printf("\n");
  printf("Answer\n");
  for (i = 0; i < M_COL; i++)
    printf("  %ld\n", answer[i]);

  free(matrix);
  free(vector);
  free(answer);

  return 0;
}


void init_array(long *data, int len, unsigned int seed)
{
  int i;
  srandom(seed);
  for (i = 0; i < len; i++) {
    data[i] = random() % NUMMAX;
    if (random() % 2 == 0) data[i] = -1 * data[i];
  }
}
